#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>

double Brent(double x1,double x3,double func(double),int itmax,double eps,double*x2)
  {
  int iter;
  double a,b,x,y1,y2,y3;
  a=min(x1,x3);
  b=max(x1,x3);
  x1=a;
  x3=b;
  *x2=(x1+x3)/2.;
  y1=func(x1);
  y2=func(*x2);
  y3=func(x3);
  if(y1<y3&&y1<y2)
    {
    *x2=x1;
    return(y1);
    }
  if(y3<y1&&y3<y2)
    {
    *x2=x3;
    return(y3);
    }
  for(iter=0;iter<itmax;iter++)
    {
    x=y1*(*x2-x3)+y2*(x3-x1)+y3*(x1-*x2);
    if(fabs(x)<eps*(x3-*x2))
      break;
    x=((*x2*(*x2)-x3*x3)*y1+(x3*x3-x1*x1)*y2+(x1*x1-*x2*(*x2))*y3)/x/2.;
    if(x<a)
      x=a;
    if(x>b)
      x=b;
    if(x<*x2-eps)
      {
      x3=*x2;
      y3=y2;
      }
    else if(x>*x2+eps)
      {
      x1=*x2;
      y1=y2;
      }
    else
      break;
    *x2=x;
    y2=func(*x2);
    }
  return(y2);
  }

int calls;

double gamma(double x)
  {
  int i;
  double g,y,z;
  static double c[9]={1.,-0.577191652,0.988205891,-0.897056937,0.918206857,
    -0.756704078,0.482199394,-0.193527818,0.035868343};
  calls++;
  y=x;
  g=1.;
  while(y>2.)
    {
    y-=1.;
    g*=y;
    }
  while(y<1.)
    {
    g/=y;
    y+=1.;
    }
  z=c[8];
  for(i=7;i>=0;i--)
    {
    z*=y-1.;
    z+=c[i];
    }
  return(z*g);
  }

int main(int argc,char**argv,char**envp)
  {
  double f,x;
  calls=0;
  f=Brent(0.5,2.5,gamma,999,FLT_EPSILON,&x);
  printf("Brent: x=%lG, f=%lG, calls=%i\n",x,f,calls);
  return(0);
  }
