/* qsort public domain version by
   Ray Gardner June 11,1987 */

static void iswap(unsigned k,int*a,int*b)
  {
  int tmp;
  do{
    tmp=*a;
    *a=*b;
    *b=tmp;
    a++;
    b++;
    }while(--k);
  }

static void cswap(unsigned k,char*a,char*b)
  {
  char tmp;
  do{
    tmp=*a;
    *a=*b;
    *b=tmp;
    a++;
    b++;
    }while(--k);
  }

#define SWAP(a,b) (*swap_fp)(n_to_swap,a,b)
#define COMP(a,b) (*comp_fp)(a,b)

typedef void (*swap_t) (unsigned,void*,void*);

void qs0rt(char*base,unsigned int nel,unsigned int width,int(*comp_fp)(void*,void *))
  {
  char*stack[40],**sp;
  char*i,*j,*limit;
  unsigned n_to_swap;
  unsigned thresh;
  swap_t swap_fp;
  if(width%sizeof(int)!=0)
    {
    swap_fp=(swap_t)cswap;
    n_to_swap=width;
    }
  else
    {
    swap_fp=(swap_t)iswap;
    n_to_swap=width/sizeof(int);
    }
  thresh=7*width;
  sp=stack;
  limit=base+nel*width;
  while(1)
    {
    while(limit-base>(int)thresh)
      {
      SWAP(((unsigned)(limit-base)>>1)-((((unsigned)(limit-base)>>1))%width)+base,base);
      i=base+width;
      j=limit-width;
      if(COMP(i,j)>0)
        SWAP(i,j);
      if(COMP(base,j)>0)
        SWAP(base,j);
      if(COMP(i,base)>0)
        SWAP(i,base);
      while(1)
        {
        do{
          i+=width;
          }while(COMP(i,base)<0);
        do{
          j-=width;
          }while(COMP(j,base)>0);
        if(i>j)
          break;
        SWAP(i,j);
        }
      SWAP(base,j);
      if(j-base>limit-i)
        {
        sp[0]=base;
        sp[1]=j;
        base=i;
        }
      else
        {
        sp[0]=i;
        sp[1]=limit;
        limit=j;
        }
      sp+=2;
      }
    i=base+width;
    while(i<limit)
      {
      j=i;
      while(j>base&&COMP(j-width,j)>0)
        {
        SWAP(j-width,j);
        j-=width;
        }
      i+=width;
      }
    if(sp>stack)
      {
      sp-=2;
      base=sp[0];
      limit=sp[1];
      }
    else
      break;
    }
  }
