#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

void QuickSortIndexedIntegers(int*M,int*I,int n)
  {
  int i,j,k,l,m;
  while(n>1)
    {
    k=I[0];
    I[0]=I[n/2];
    I[n/2]=k;
    i=0;
    j=n;
    while(1)
      {
      m=M[I[0]];
      while(j>0)
        {
        j--;
        if(M[I[j]]<=m)
          break;
        }
      while(1)
        {
        i++;
        if(i>=j)
          break;
        if(M[I[i]]>=m)
          break;
        }
      if(i>=j)
        break;
      k=I[i];
      I[i]=I[j];
      I[j]=k;
      }
    k=I[0];
    I[0]=I[j];
    I[j]=k;
    k=j;
    j++;
    l=n-j;
    if(k<l)
      {
      QuickSortIndexedIntegers(M,I,k);
      I+=j;
      n=l;
      }
    else
      {
      QuickSortIndexedIntegers(M,I+j,l);
      n=k;
      }
    }
  }

void QuickSortIndexedDoubles(double*D,int*I,int n)
  {
  int i,j,k,l;
  double d;
  while(n>1)
    {
    k=I[0];
    I[0]=I[n/2];
    I[n/2]=k;
    i=0;
    j=n;
    while(1)
      {
      d=D[I[0]];
      while(j>0)
        {
        j--;
        if(D[I[j]]<=d)
          break;
        }
      while(1)
        {
        i++;
        if(i>=j)
          break;
        if(D[I[i]]>=d)
          break;
        }
      if(i>=j)
        break;
      k=I[i];
      I[i]=I[j];
      I[j]=k;
      }
    k=I[0];
    I[0]=I[j];
    I[j]=k;
    k=j;
    j++;
    l=n-j;
    if(k<l)
      {
      QuickSortIndexedDoubles(D,I,k);
      I+=j;
      n=l;
      }
    else
      {
      QuickSortIndexedDoubles(D,I+j,l);
      n=k;
      }
    }
  }

void QuickSortIndexedRGBs(DWORD*RGB,int*I,int n)
  {
  int i,j,k,l;
  DWORD rgb;
  while(n>1)
    {
    k=I[0];
    I[0]=I[n/2];
    I[n/2]=k;
    i=0;
    j=n;
    while(1)
      {
      rgb=RGB[I[0]];
      while(j>0)
        {
        j--;
        if(RGB[I[j]]<=rgb)
          break;
        }
      while(1)
        {
        i++;
        if(i>=j)
          break;
        if(RGB[I[i]]>=rgb)
          break;
        }
      if(i>=j)
        break;
      k=I[i];
      I[i]=I[j];
      I[j]=k;
      }
    k=I[0];
    I[0]=I[j];
    I[j]=k;
    k=j;
    j++;
    l=n-j;
    if(k<l)
      {
      QuickSortIndexedRGBs(RGB,I,k);
      I+=j;
      n=l;
      }
    else
      {
      QuickSortIndexedRGBs(RGB,I+j,l);
      n=k;
      }
    }
  }

void TestIntegers(int n)
  {
  int*I,i,*M;
  I=calloc(n,sizeof(int));
  M=calloc(n,sizeof(int));
  for(i=0;i<n;i++)
    {
    I[i]=i;
    M[i]=rand();
    }
  printf("before:");
  for(i=0;i<n;i++)
    printf(" %i",M[I[i]]);
  printf("\n");
  QuickSortIndexedIntegers(M,I,n);
  printf("after:");
  for(i=0;i<n;i++)
    printf(" %i",M[I[i]]);
  printf("\n");
  }

void TestDoubles(int n)
  {
  int*I,i;
  double*D;
  D=calloc(n,sizeof(double));
  I=calloc(n,sizeof(int));
  for(i=0;i<n;i++)
    {
    I[i]=i;
    D[i]=(rand()-16383.)/8192.;
    }
  printf("before:");
  for(i=0;i<n;i++)
    printf(" %lG",D[I[i]]);
  printf("\n");
  QuickSortIndexedDoubles(D,I,n);
  printf("after:");
  for(i=0;i<n;i++)
    printf(" %lG",D[I[i]]);
  printf("\n");
  }

void TestRGBs(int n)
  {
  int*I,i;
  BYTE b,g,r;
  DWORD*RGB;
  I=calloc(n,sizeof(int));
  RGB=calloc(n,sizeof(int));
  for(i=0;i<n;i++)
    {
    I[i]=i;
    r=(BYTE)(rand()%256);
    g=(BYTE)(rand()%256);
    b=(BYTE)(rand()%256);
    RGB[i]=(((DWORD)r)<<16) | (((DWORD)g)<<8) | ((DWORD)b);
    }
  printf("before:");
  for(i=0;i<n;i++)
    printf(" %06X",RGB[I[i]]);
  printf("\n");
  QuickSortIndexedIntegers(RGB,I,n);
  printf("after:");
  for(i=0;i<n;i++)
    printf(" %06X",RGB[I[i]]);
  printf("\n");
  }

int main(int argc,char**argv,char**envp)
  {
//TestIntegers(20);
//TestDoubles(20);
  TestRGBs(20);
  return(0);
  }
  