#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

typedef unsigned char BYTE;
typedef unsigned __int32 DWORD;

short int _rand(void)
  {
  static DWORD next=1;
  next=next*1103515245UL+12345UL;
  return((unsigned short int)(next/0x10000UL)&0x7FFF);
  }

DWORD drand() /* 32-bit uniformly-distributed random integer */
  {
  union{DWORD d;BYTE b[4];}u;
  u.b[0]=(BYTE)(rand()&0xFF);
  u.b[1]=(BYTE)(rand()&0xFF);
  u.b[2]=(BYTE)(rand()&0xFF);
  u.b[3]=(BYTE)(rand()&0x7F);
  return(u.d);
  }

int nrand() /* 15-bit uniformly-distributed random integer */
  {
  int i,r;
  for(r=i=0;i<12;i++)
    r+=rand();
  return(r/12);
  }

double randnorm() /* 15-bit normally-distributed random integer */
  {
  int i;
  double r;
  for(r=i=0;i<12;i++)
    r+=rand()/32767.;
  return((r-6.)/6.);
  }

double randist(double a,double s) /* normally-distributed random real */
  {                               /* with mean of a and std.dev. of s */
  return(a+6.*s*randnorm());
  }

typedef struct{int f,s;}card;
typedef struct{card c[52];}deck;

void initialize(deck*d)
  {
  short f,i,s;
  printf("initializing deck\n");
  for(i=s=0;s<4;s++)
    {
    for(f=0;f<13;f++,i++)
      {
      d->c[i].f=f;
      d->c[i].s=s;
      }
    }
  }

double score(deck*d)
  {
  int f,i,j,k,l;
  double s=0.;
  for(i=0;i<51+52;) /* increasing straights */
    {
    for(f=l=1;i+l<52;l++)
      {
      j=(i+l)%52;
      k=(i+l-1)%52;
      if(d->c[j].f!=d->c[k].f+1)
        break;
      else if(d->c[j].s!=d->c[k].s)
        f=0;
      }
    if(f&&l>1)  /* straight flush */
      s+=pow(13,l-1)*pow(4,l-1);
    else if(l>1)
      s+=pow(13,l-1);
    i+=l;
    }
  for(i=0;i<51+52;) /* decreasing straights */
    {
    for(f=l=1;i+l<52;l++)
      {
      j=(i+l)%52;
      k=(i+l-1)%52;
      if(d->c[j].f!=d->c[k].f-1)
        break;
      else if(d->c[j].s!=d->c[k].s)
        f=0;
      }
    if(f&&l>1) /* straight flush */
      s+=pow(13,l-1)*pow(4,l-1);
    else if(l>1)
      s+=pow(13,l-1);
    i+=l;
    }
  for(i=0;i<51+52;) /* 2, 3, 4 of a kind */
    {
    for(l=1;i+l<52;l++)
      {
      j=(i+l)%52;
      k=(i+l-1)%52;
      if(d->c[j].f!=d->c[k].f)
        break;
      }
    if(l>1)
      s+=pow(4,l-1);
    i+=l;
    }
  return s;
  }

void shuffle(deck*d,int n)
  {
  int i,j,k;
  card c;
  if(n>1)
    printf("shuffling deck (%i swaps)\n",n);
  for(i=0;i<n;i++)
    {
    do{
      j=rand()%52;
      k=rand()%52;
      }while(k==j);
    c=d->c[j];
    d->c[j]=d->c[k];
    d->c[k]=c;
    }
  }

char*face[13]={"A","2","3","4","5","6","7","8","9","10","J","Q","K"};
char*suit[4]={"S","H","D","C"};

void list(deck*d,int show)
  {
  char ccc[]="???";
  int i;
  if(show)
    {
    for(i=0;i<52;i++)
      {
      strcpy(ccc,face[d->c[i].f]);
      strcat(ccc,suit[d->c[i].s]);
      if((i+1)%13)
        printf("%-3s ",ccc);
      else
        printf("%s\n",ccc);
      }
    }
  printf("score=%.0lf\n",score(d));
  }

int main(int argc,char**argv,char**envp)
  {
  int i;
  deck d;
  time_t t;
  time(&t);
  srand((unsigned int)t);
  initialize(&d);
  list(&d,0);
  for(i=1;i<52;i++)
    {
    shuffle(&d,1);
    list(&d,0);
    }
  list(&d,1);
  return(0);
  }
   